//light ps (c)KA50
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <grp.h>
#include <unistd.h>
#include <dirent.h>
#include <limits.h>
#include <unistd.h>

//struct for save the process
struct process {

	int pid;
	char state;
	char *comm;
	int ppid; 
	int tty; 
	int tpgid; 
	unsigned int flags; 
	int utime; 
	int stime; 
	int time;
	int priority;
	unsigned int nice;
	unsigned int vsize;
	unsigned int rss;
	unsigned int wchan;
	
	char *cmdline;	
	int uid;
	char *uname;
	int gid;
	char *gname;
	
}; 

//struct for save linked list of processes
typedef struct tnode {
	struct process value;
	struct tnode *next;
} allproc;
allproc *p;
allproc *dl, *tc;

#define SHOW_NOTHING 0x00;
#define SHOW_FLAGS 0x01
#define SHOW_STATE 0x02
#define SHOW_UID 0x04
#define SHOW_UNAME 0x08
#define SHOW_PID 0x10
#define SHOW_PPID 0x20
#define SHOW_C 0x40
#define SHOW_PRI 0x80
#define SHOW_NI 0x100
#define SHOW_ADDR 0x200
#define SHOW_SZ 0x400
#define SHOW_WCHAN 0x800
#define SHOW_STIME 0x1000
#define SHOW_TTY 0x2000
#define SHOW_TIME 0x4000
#define SHOW_CMD 0x8000

#define SHOW_ALL (SHOW_PID | SHOW_TTY | SHOW_TIME | SHOW_CMD)
#define SHOW_L (SHOW_FLAGS | SHOW_STATE | SHOW_UID | SHOW_PID | SHOW_PPID | SHOW_C | SHOW_PRI | SHOW_NI | SHOW_ADDR | SHOW_SZ|SHOW_WCHAN | SHOW_TTY | SHOW_TIME | SHOW_CMD)
#define SHOW_F (SHOW_UNAME | SHOW_PID | SHOW_PPID | SHOW_C | SHOW_STIME| SHOW_TTY | SHOW_TIME | SHOW_CMD)

void
listdev(allproc *p)
{
	char* dirname = "/dev";
	struct dirent *dirbuf;
	DIR *fddir;
	ino_t dot_ino = 0, dotdot_ino = 0;

	if((fddir = opendir (dirname)) == NULL) {
		fprintf(stderr, "Can't read %s\n", dirname);
		return 1;
	}
	int b = 1;
	while ((dirbuf = readdir (fddir)) != NULL ) {
		char *dname = dirbuf->d_name;
		if ((dname == '.') && (dname[1] == 0) ||
		    (dname == '.') && (dname[1] == '.') &&
		    (dname[2] == 0)) {
			continue;
		} else {
			char path[PATH_MAX];
			snprintf(path,sizeof(path),"%s/%s", dirname, dname);
			struct stat st;
			int err = stat(path,&st);
			if (err) {
				fprintf(stderr, "Can't get stat from %s\n", path);
			} else {
				if (st.st_rdev>0) {
					if (st.st_rdev == p->value.tty){
						printf("%6s",dname);
						b = 0;
						break;
					}
				}
			}
		}
	}
	closedir (fddir);
	if (b) {
		printf("     ?");
	}
}

//see the process list
void 
list(allproc *p,int mask) 
{
	int cnt = 0;
	while (p->next != NULL) {
lab:		if (mask & SHOW_FLAGS) {
			if (!cnt) {
				printf("         F  ");
			} else
				printf("%10u ",p->value.flags);
		}
		if (mask & SHOW_STATE) {
			if (!cnt) {
				printf("S  ");
			} else
				printf("%2c",p->value.state);
		}
		if (mask & SHOW_UID) {
			if (!cnt) {
				printf("UID  ");
			} else
				printf(" %4d ",p->value.uid);
		}
		if (mask & SHOW_UNAME) {
			if (!cnt) {
				printf("        UID   ");
			} else
				printf(" %11s ",p->value.uname);
		}
		if (mask & SHOW_PID) {
			if (!cnt) {
				printf("PID  ");
			} else 
				printf("%4d ",p->value.pid);
		}
		if (mask & SHOW_PPID) {
			if (!cnt) {
				printf("PPID  ");
			} else 
				printf(" %4d ",p->value.ppid);
		}
		if (mask & SHOW_C) {
			if (!cnt) {
				printf("C ");
			} else 
				printf(" - ");
		}
		if (mask & SHOW_PRI) {
			if (!cnt) {
				printf(" PRI    ");
			} else
				printf(" %3d ",p->value.priority);
		}
		if (mask & SHOW_NI) {
			if (!cnt) {
				printf("NI    ");
			} else 
				printf(" %4u ",p->value.nice);
		}
		if (mask & SHOW_ADDR) {
			if (!cnt) {
				printf("ADDR   ");
			} else 
				printf("      -");
		}
		if (mask & SHOW_SZ) {
			if (!cnt) {
				printf("SZ   ");
			} else 
				printf(" %4u ",p->value.vsize);
		}
		if (mask & SHOW_WCHAN) {
			if (!cnt) {
				printf("WCHAN  ");
			} else 
				printf("  -      ");
		}
		if (mask & SHOW_STIME) {
			
		}
		if (mask & SHOW_TTY) {
			if (!cnt) {
				printf("   TTY ");
			} else {
				listdev(p);
			}
		}
		if (mask & SHOW_TIME) {
			if (!cnt) {
				printf("    TIME  ");
			} else {
				int t = p->value.time;
				char c1 = 0;
				char c2 = 0;
				char c3 = 0;
				int h = t / 3600;
				int m = (t - h * 3600) / 60;
				int s = t - h * 3600 - m * 60;
				if (h < 10) {
					c1 = '0';
				}
				if (m < 10) {
					c2 = '0';
				}
				if (s < 10) {
					c3 = '0';
				}
				
				printf(" %c%d:%c%d:%c%d ",c1,h,c2,m,c3,s);
			}
		}
		if (mask & SHOW_CMD) {
			if (!cnt) {
				printf("CMD");
			} else
				printf(" %s ",p->value.cmdline);
		}
		
		printf("\n");
		cnt++;
		if (!cnt){
			goto lab;
		}
		p = p -> next;
		
	}
}

//if dirname is a process directory
int 
isproc(const char *dn)
{
	while (isdigit(*dn))
		dn++;
	
	return (*dn == 0);
}

//checking malloc
void* 
xmalloc(size_t size)
{
	void* obj = malloc(size);
	if (obj == NULL){
		fprintf(stderr,"Memory allocation error\n");
		exit(1);
	}
	return obj;
}

#define PROCDIR	"/proc/"

//get and print information about proccess whith PID=procname
int
getinfo(const char *procname,struct process *cur)
{
	char buf[PATH_MAX];
	int i;
	int ticks_per_sec;
	int uid,gid;
	char p[16] = "/proc/";
	snprintf(buf, sizeof(buf), "%s%s/stat", PROCDIR, procname);
	char path[PATH_MAX];
	
	snprintf(path,sizeof(path),"%s%s", PROCDIR, procname);
	struct stat st;
	int err = stat(path,&st);
	if (err) {
		fprintf(stderr,"Can't get stat from %s\n",path);
	} else {
		uid = st.st_uid;
		cur->uid = uid;
		gid = st.st_gid;
		cur->gid = gid;
	
		struct passwd *psw;
		psw = getpwuid(uid);
		if (psw == NULL) {
			fprintf(stderr,"Can't get info about %d user",uid);	
		} else {
			cur->uname = xmalloc(sizeof(psw->pw_name));
			strcpy(cur->uname, psw->pw_name);
		}
	
		struct group *gr;
		gr = getgrgid(gid);
		if (gr == NULL) {
			fprintf(stderr,"Can't get info about %d group",gid);
		} else {
			cur->gname = xmalloc(sizeof(gr->gr_name));
			strcpy(cur->gname, gr->gr_name);
		}
	}
	
	//analysing stat file
	FILE *f;
	f = fopen(buf,"r");
	if (f == NULL) {
		fprintf(stderr,"Cannot open file: %s \n",buf);
	} else {
		fscanf(f,"%d",&cur->pid);
		cur->comm = xmalloc(PATH_MAX);
		char cm;
		fscanf(f, "%c",&cm);
		fscanf(f, "%c",&cm);
		fscanf(f, "%c",&cm);
		i=0;
		*cur->comm = '[';
		cur->comm++;
		i++;
		do {
			*cur->comm = cm;
			cur->comm++;
			i++;
			fscanf(f, "%c",&cm);
		} while (cm!=')');
		
		fscanf(f, "%c",&cm);
		*cur->comm = ']';
		cur->comm++;
		i++;
		cur->comm -= i;
		fscanf(f,"%c %d %*d %*d %d %*d %u %*u %*u %*u %*u %d %d %*d %*d %*d %d %u %*d %*u %*d %u %u %*u %*u %*u %*u %*u %*u %*d %*d %*d %*d %u",
		&cur->state,&cur->ppid,&cur->tty,&cur->flags,&cur->utime,&cur->stime,
		&cur->priority,&cur->nice,&cur->vsize,&cur->rss,&cur->wchan);
		
		ticks_per_sec = sysconf(_SC_CLK_TCK);
		cur->time = (cur->utime + cur->stime) / ticks_per_sec;
		cur->stime = cur->stime / ticks_per_sec;
		fclose(f);

		char cbuf[PATH_MAX];
		snprintf(cbuf, sizeof(buf), "%s%s/cmdline", PROCDIR, procname);

		//analysing cmdline file
		FILE *fc;
		fc = fopen(cbuf,"r");
		if (fc == NULL){
			printf("Cannot open file: %s \n",cbuf);	
		} else {
			cur->cmdline = xmalloc(PATH_MAX);
			fread(cur->cmdline,1,PATH_MAX,fc);
			
			if (*cur->cmdline == 0){
				cur->cmdline = cur->comm;
			}
			fclose(fc);
		}
	}

}

//listing all directories in /proc
int 
listdir (char *dirname) 
{
        struct dirent *dirbuf;
        DIR *fddir;
        ino_t dot_ino = 0, dotdot_ino = 0;

        if((fddir = opendir (dirname)) == NULL) {
            	fprintf(stderr, "Can't read %s\n", dirname);
            	return 1;
        }
        /* reading directories in /proc */
	
	dl = xmalloc(sizeof(allproc));
	int cnt = 0;
        while ((dirbuf = readdir (fddir)) != NULL ) {
		char *procname = dirbuf->d_name;
		if ((procname == '.') && (procname[1] == 0) ||
		    (procname == '.') && (procname[1] == '.') &&
		    (procname[2] == 0)) {
			continue;
		} else {
			if (isproc(procname)) {
				char *dn = procname;
				struct process ans;
				getinfo(dn,&ans);
				p = xmalloc(sizeof(allproc));
				p->value = ans;
				p->next = dl;
				dl = p;
				
			}
		}
        }
        closedir (fddir);

        return 0;
}

//main function
int 
main(int argc, char* argv[]) 
{
	int mask = SHOW_NOTHING;
	if (argc == 1) {
		printf("This is the pslite project. (C)KA50\n");	
	} else {
		char opt;
		char *optns = "a-:l-:f-:";
		while ((opt = getopt(argc, argv, optns)) != -1) {
			switch (opt) {
				case 'a': mask = mask | SHOW_ALL; break;
				case 'l': mask = mask | SHOW_L; break;
				case 'f': mask = mask | SHOW_F; break;
				default: {
					printf("Wrong argument\n");
					return 1;	
				}
			}
		}
		listdir("/proc");
		list(p, mask);
	}
	
	

        return 0;
}
